knowledge_accounting_system.WEB/Controllers/AdminController.cs
using knowledge_accounting_system.BLL.DTO;
using knowledge_accounting_system.BLL.Infrastructure;
using knowledge_accounting_system.BLL.Interfaces;
using knowledge_accounting_system.BLL.Services;
using knowledge_accounting_system.WEB.Models;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace knowledge_accounting_system.WEB.Controllers
{
    [Authorize(Roles="admin")]
    public class AdminController : Controller
    {

        private IUserService UserService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IUserService>();
            }
        }

        // GET: Admin
        public ActionResult Index()
        {
            return View(UserService.Users);
        }

        public ActionResult Create()
        {
            return View(new RegisterModel());
        }

        [HttpPost]
        public async Task<ActionResult> Create(RegisterModel model)
        {
            if (ModelState.IsValid)
            {
                UserDTO userDto = new UserDTO
                {
                    Email = model.Email,
                    Password = model.Password,
                    Name = model.Name,
                    Role = "user"
                };
                OperationDetails operationDetails = await UserService.Create(userDto);
                if (operationDetails.Succedeed)
                    return RedirectToAction("Index");
                else
                    ModelState.AddModelError(operationDetails.Property, operationDetails.Message);
            }
            return View(model);
        }
        [HttpPost]
        public async Task<ActionResult> Delete(string id)
        {
            UserDTO user = await UserService.FindUserByIdAsync(id);
            if (user != null) 
            {
                OperationDetails operationDetails = await UserService.DeleteUserAsync(user);
                if (operationDetails.Succedeed)
                {
                    return RedirectToAction("Index");
                }
                else 
                {
                    ModelState.AddModelError(operationDetails.Property, operationDetails.Message);
                }
            }
            return View();
        }

        public async Task<ActionResult> Edit(string id)
        {
            if (id == null) { return RedirectToAction("Index"); }
            UserDTO user = await UserService.FindUserByIdAsync(id);
            if (user != null)
            {
                return View(user);
            }
            return RedirectToAction("Index");
        }

        [HttpPost]
        public async Task<ActionResult> Edit(string id, string userName, string email, string password)
        {
            UserDTO user = await UserService.FindUserByIdAsync(id);
            if (user != null)
            {
                user.Email = email;
                OperationDetails validEmail = await UserService.UserValidatorAsync(user);
                if (!validEmail.Succedeed)
                {
                    ModelState.AddModelError(validEmail.Property, validEmail.Message);
                }

                OperationDetails validPass = null;
                if (password != string.Empty)
                {
                    validPass = await UserService.PasswordValidatorAsync(password);
                    if (validPass.Succedeed)
                    {
                        user.Password = UserService.HashPassword(password);
                    }
                    else
                    {
                        ModelState.AddModelError(validPass.Property, validPass.Message);
                    }
                }

                user.Name = userName;

                if ((validEmail.Succedeed && validPass == null) || (validEmail.Succedeed && password != string.Empty && validPass.Succedeed)) 
                {
                    OperationDetails result = await UserService.UserUpdateAsync(user);
                    if (result.Succedeed)
                    {
                        return RedirectToAction("Index");
                    }
                    else 
                    {
                        ModelState.AddModelError(result.Property, result.Message);
                    }
                }
            }
            else 
            {
                ModelState.AddModelError("", "Пользователь не найден");
            }
            return View(user);
        }
    }
}

knowledge_accounting_system.WEB/Controllers/MarkAdminController.cs
using knowledge_accounting_system.BLL.DTO;
using knowledge_accounting_system.BLL.Infrastructure;
using knowledge_accounting_system.BLL.Interfaces;
using knowledge_accounting_system.WEB.Models;
using Microsoft.AspNet.Identity.Owin;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace knowledge_accounting_system.WEB.Controllers
{
    [Authorize(Roles = "admin")]
    public class MarkAdminController : Controller
    {
        private IMarkService MarkService 
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IMarkService>();
            }
        }

        // GET: Mark
        public ActionResult Index()
        {
            return View(MarkService.Marks);
        }

        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> Create([Required] string name)
        {
            if (name == "") 
            {
                ModelState.AddModelError("","Ведите названия предмета");
                return View(); 
            }
            if (ModelState.IsValid)
            {
                OperationDetails result = await MarkService.Create(name);
                if (result.Succedeed)
                {
                    return RedirectToAction("Index");
                }                
            }
            ModelState.AddModelError("","Такой предмет уже существует");
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> Delete(int id)
        {
            var role = await MarkService.FindMarkByIdAsync(id);
            if (role != null)
            {
                OperationDetails result = await MarkService.DeleteMarkAsync(role);
                if (result.Succedeed)
                {
                    return RedirectToAction("Index");
                }
                ModelState.AddModelError(result.Property, result.Message);
            }
            return View();
        }
    }
}

knowledge_accounting_system.WEB/Controllers/RoleAdminController.cs
using knowledge_accounting_system.BLL.Infrastructure;
using knowledge_accounting_system.BLL.Interfaces;
using knowledge_accounting_system.WEB.Models;
using Microsoft.AspNet.Identity.Owin;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace knowledge_accounting_system.WEB.Controllers
{
    [Authorize(Roles = "admin")]
    public class RoleAdminController : Controller
    {
        private IUserService UserService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IUserService>();
            }
        }

        private IRoleService RoleService 
        {
            get 
            {
                return HttpContext.GetOwinContext().GetUserManager<IRoleService>();
            }
        }
        // GET: Role
        public ActionResult Index()
        {
            return View(RoleService.Roles.ToList());
        }

        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> Create([Required] string name)
        {
            if (ModelState.IsValid)
            {
                OperationDetails result = await RoleService.Create(name);
                if (result.Succedeed)
                {
                    return RedirectToAction("Index");
                }
                ModelState.AddModelError(result.Property, result.Message);
            }
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> Delete(string id)
        {
            var role = await RoleService.FindRoleByIdAsync(id);
            if (role != null) 
            {
                OperationDetails result = await RoleService.DeleteRoleAsync(role);
                if (result.Succedeed) 
                {
                    return RedirectToAction("Index");
                }
                ModelState.AddModelError(result.Property, result.Message);
            }
            return View("Error", new string[] { "Роль не найдена" });
        }

        public async Task<ActionResult> Edit(string id)
        {
            if (id == null) { return RedirectToAction("Index"); }
            var role = await RoleService.FindRoleByIdAsync(id);
            string[] memberIDs = role.Users.Select(x => x.UserId).ToArray();
            IEnumerable<object> members = UserService.Users.Where(x => memberIDs.Any(y => y == x.Id));

            IEnumerable<object> nonMembers = UserService.Users.Except(members);

            return View(new RoleEditModel
            {
                Role = role,
                Members = members,
                NonMembers = nonMembers
            });
        }

        [HttpPost]
        public async Task<ActionResult> Edit(RoleModificationModel model)
        {
            OperationDetails result;
            if (ModelState.IsValid) 
            {
                foreach (string userId in model.IdsToAdd ?? new string[] { }) 
                {
                    result = await UserService.AddToRoleAsync(userId, model.RoleName);

                    if (!result.Succedeed) 
                    {
                        return View("Error", result.Message);
                    }
                }
                foreach (string userId in model.IdsToDelete ?? new string[] { })
                {
                    result = await UserService.RemoveFromRoleAsync(userId,
                    model.RoleName);

                    if (!result.Succedeed)
                    {
                        return View("Error", result.Message);
                    }
                }
                return RedirectToAction("Index");
            }
            return View("Error", new string[] { "Роль не найдена" });
        }
    }
}

knowledge_accounting_system.WEB/Views/RoleAdmin/Create.cshtml
@model string
@{
    ViewBag.Title = "Создание роли";
    Layout = "~/Views/Shared/_Menu.cshtml";
}

<h2>Создать роль</h2>
@Html.ValidationSummary()
@using (Html.BeginForm())
{
    <div class="form-group">
        <label>Название</label>
        <input name="name" value="@Model" class="form-control" />
    </div>
    <button type="submit" class="btn btn-primary">Создать</button>
    @Html.ActionLink("Отмена", "Index", null, new { @class = "btn btn-default" })
}

knowledge_accounting_system.WEB/Views/RoleAdmin/Edit.cshtml
@using knowledge_accounting_system.DAL.Entities
@using knowledge_accounting_system.WEB.Models
@model RoleEditModel
@{
    ViewBag.Title = "Изменить роль";
    Layout = "~/Views/Shared/_Menu.cshtml";
}

<h2>Изменить роль</h2>
@Html.ValidationSummary()
@using (Html.BeginForm())
{
    <input type="hidden" name="roleName" value="@Model.Role.Name" />
    <div class="panel panel-primary">
        <div class="panel-heading">Добавить в роль <b>@Model.Role.Name</b></div>
        <table class="table table-striped">
            @if (Model.NonMembers.Count() == 0)
            {
                <tr>
                    <td colspan="2">Все пользователи в роли</td>
                </tr>
            }
            else
            {
                <tr>
                    <td>User ID</td>
                    <td>Добавить в роль</td>
                </tr>
                foreach (ApplicationUser user in Model.NonMembers)
                {
                    <tr>
                        <td>@user.UserName</td>
                        <td>
                            <input type="checkbox" name="IdsToAdd" value="@user.Id">
                        </td>
                    </tr>
                }
            }
        </table>
    </div>

    <div class="panel panel-primary">
        <div class="panel-heading">Удалить из роли <b>@Model.Role.Name</b></div>
        <table class="table table-striped">
            @if (Model.Members.Count() == 0)
            {
                <tr>
                    <td colspan="2">Нет пользователей в роли</td>
                </tr>
            }
            else
            {
                <tr>
                    <td>User ID</td>
                    <td>Удалить из роли</td>
                </tr>
                foreach (ApplicationUser user in Model.Members)
                {
                    <tr>
                        <td>@user.UserName</td>
                        <td>
                            <input type="checkbox" name="IdsToDelete" value="@user.Id">
                        </td>
                    </tr>
                }
            }
        </table>
    </div>
    <button type="submit" class="btn btn-primary">Сохранить</button>
    @Html.ActionLink("Отмена", "Index", null, new { @class = "btn btn-default" })
}

knowledge_accounting_system.WEB/Views/RoleAdmin/Index.cshtml
@using knowledge_accounting_system.BLL.Infrastructure
@using knowledge_accounting_system.DAL.Entities
@using Microsoft.AspNet.Identity.EntityFramework;
@model List<IdentityRole>

@{
    ViewBag.Title = "Роли";
    Layout = "~/Views/Shared/_Menu.cshtml";
}

<div class="panel panel-primary">
    <div class="panel-heading">Roles</div>
    <table class="table table-striped">
        <tr>
            <th>ID</th>
            <th>Название</th>
            <th>Пользователи</th>
            <th style="min-width: 150px"></th>
        </tr>
        @if (Model.Count() == 0)
        {
            <tr>
                <td colspan="4" class="text-center">Нет ролей</td>
            </tr>
        }
        else
        {
            foreach (ApplicationRole role in Model)
            {
                <tr>
                    <td>@role.Id</td>
                    <td>@role.Name</td>
                    <td>
                        @if (role.Users.Count == 0)
                        {
                            @: Нет пользователей в этой роли
                        }
                        else
                        {
                            <p>
                                @string.Join(", ", role.Users.Select(x => Html.GetUserName(x.UserId)))
                            </p>
                        }
                    </td>
                    <td>
                        @using (Html.BeginForm("Delete", "RoleAdmin", new { id = role.Id }))
                        {
                            @Html.ActionLink("Изменить", "Edit", new { id = role.Id },
                                new { @class = "btn btn-primary btn-xs", style = "float:left; margin-right:5px" })
                            <button class="btn btn-danger btn-xs" type="submit">Удалить</button>
                        }
                    </td>
                </tr>
            }
        }
    </table>
</div>
<div>
    @Html.ActionLink("Создать", "Create", null, new { @class = "btn btn-primary" })
    @Html.ActionLink("Выйти", "Logout", "Account", null, new { @class = "btn btn-primary", style = "float:right; margin-left:10px" })
    @Html.ActionLink("Юзеры", "Index", "Admin", null, new { @class = "btn btn-primary", style = "float:right; margin-left:10px" })
    @Html.ActionLink("Предметы", "Index", "MarkAdmin", null, new { @class = "btn btn-primary", style = "float:right" })
</div>